

var project = ccPage.contextObject;
var WSShell = project.Application.ObjectCreator.CreateNew("WScript.Shell");
var sh = project.Application.FileManager;

// get pointer to message window
var mesWindow = project.Application.MessagesWindow;
var fso = project.Application.CCFileSystem;
var err = "";
var VersionConflict=project.Application.translations.resourceString("Pattern_Net_VersionConflict");
var NoCompiler=project.Application.translations.resourceString("Pattern_Net_UnableFindCompiler");//"Unable to find C# compiler. Please specify Tools>Options>Paths>.NET SDK" 
var BuildError=project.Application.translations.resourceString("Pattern_Net_BuildError");//"Build Script Error" 
var Running=project.Application.translations.resourceString("Pattern_Net_Running");//"Running:"
var Successful=project.Application.translations.resourceString("Pattern_Net_Successful");//"Build finished"
var Output=project.Application.translations.resourceString("Pattern_Net_Output");//"Output"
function getNetPath(sVersion)
{
  var fs = project.Application.CCFileSystem;
  var folder = fs.directory("WindowsFolder").Path+"\\Microsoft.NET\\Framework";

  if(sVersion=="1.0")
	folder += "\\v1.0.3705";
  else
	folder += "\\v1.1.4322";
  
  if(fs.fileExists(folder+"\\mscorlib.dll"))
  {
	return folder+"\\";
	
  }	
  else
  {
	  mesWindow.AddLogEntry( 2,VersionConflict);
	  var path=project.Application.options.item( "Paths", "NETSDKPath" );
	  if(path.length==0) path="C:\\WINNT\\Microsoft.NET\\Framework\\v1.0.3705"
	  while ( path.charAt(path.length-1) == '\\' ) {
		  path = path.substring(0, path.length-1 );
	  }
	  return path+"\\";
  }
}


if ( err != "" ) {
  mesWindow.AddLogEntry( 3, err );
}  
else {
  // path to temporary directory for build LiveData application
  var path = project.getProperty("TempShortPublishPath")+"\\";
  var logFile = path+"build.log";

  if ( fso.FileExists ( logFile ) ) {
    fso.FileDelete( logFile );
  }

  // check if compiler is exist
  var cscExists = true;
  var CscPath=getNetPath(project.getProperty("targetVersion"));
  if ( !fso.FileExists ( CscPath+"csc.exe" ) ) {
    mesWindow.AddLogEntry( 3, NoCompiler);
    cscExists = false;
  }

  // build command and parameters for building application
  var cscCmd = path+"MakeAll.bat "+path.substring( 0, 2)+" "+path;
  
  var buildResult = false;
  if ( cscCmd != "" &&cscExists) {

    var params = "";
    var cmd = cscCmd;  
    var env = WSShell.Environment;
    var OS = env ( "OS" );
    var cmdOs = "command.com";
    if ( OS == "Windows_NT" ) {
        cmdOs = "cmd";
    }

    mesWindow.AddLogEntry( 1, Running + "\n" + cmd + " " + params );
    mesWindow.AddLogEntry( 1, "=======================================");
    try {
//      WSShell.Run ( cmd + params, 1, true );
        sh.Run( cmdOs, " /E:8192 /c " + cscCmd, path + "build.log", project.application  );
    }catch(e) {mesWindow.AddLogEntry( 3, BuildError + e);}

    // output message file to message window
    var buildLog = "";
    if ( fso.FileExists ( logFile ) ) {
      mesWindow.AddLogEntry( 1, Output + "\n" );
      buildLog = fso.ReadFileContent( logFile );
    }
    var pos = buildLog.indexOf ( "error CS" );
    if ( pos > -1 ){ 
		try
		{
	      var defaultDialogButton = WSShell.RegRead("HKLM\\Software\\YesSoftware\\CodeChargeStudio\\DefaultDialogButton");
		}
		catch(e)
		{}

	if(defaultDialogButton=="Ok")
	{
		  buildResult = true;
	}
	  else if (defaultDialogButton=="Cancel")
	{
		  buildResult = false;
	}
	else
	{
      buildResult = (6 == sh.MsgBox(project.Application.translations.resourceString("Pattern_NetBuildError"), "CodeCharge Studio", 0x00000004 | 0x00000030));
	}
      mesWindow.AddLogEntry( 3, buildLog );
      }
    else{
      buildResult = true;
      mesWindow.AddLogEntry( 1, buildLog );
    }
    delete shell;
    shell = null;
  }

  if ( buildResult ){
    ccPage.namedValue("deploymentDir") = path;
    ccPage.namedValue("result") = "true";
  }
  else
    ccPage.namedValue("result") = "false";

  mesWindow.AddLogEntry( 1, "\n=======================================");
  mesWindow.AddLogEntry( 1, Successful);
   delete WSShell;
   WSShell = null;

   delete sh;
   sh = null;

}