var project = ccPage.contextObject;
var application = project.Application;
var WSShell = application.ObjectCreator.CreateNew("WScript.Shell");
var sh = application.FileManager;
var mesWindow = application.MessagesWindow;
var ccsFileSystem = application.CCFileSystem;
var projectName = project.name;
var projectLang = project.lang;
var projectPath = project.path;

//    mesWindow(1,"start script");

var posTmp = projectPath.lastIndexOf("\\"+projectName+".ccs");
var projectFolder = "";
if ( posTmp > -1 ) {
    projectFolder = projectPath.substr(0,posTmp);
}

var cPage = project.CurrentPage;
var pagePath = "";
var pageName = "";
if ( cPage != null ) {
    pagePath = cPage.path;
    pagePath = pagePath.substring(projectFolder.length);
    pageName = cPage.name;
}

var pageExt = ".jsp";
if ( projectLang == "ServletTemplates" ) {
    pageExt = ".do";
}

pageName = replace( ".ccp", pageExt, pagePath );
pageName = replace( "\\", "/", pageName );

// get java properties from project
var env = WSShell.Environment;

var strJavaHome = project.application.options.item( "Paths", "JavaJDKPath" );
var strAntHome = project.application.options.item( "Paths", "JavaANTPath" );
var strCCSHome = project.application.options.item( "Paths", "Components" );

var buildErr = "";

var ccsPos = strCCSHome.indexOf( "\\Components" );
if ( ccsPos > -1 ) {
    strCCSHome = strCCSHome.substring( 0, ccsPos );
}

// if java properties is not defined within project
// get it from environment
if ( strJavaHome == "" ) {
    strJavaHome = env( "JAVA_HOME" );
}
if ( strAntHome == "" ) {
    strAntHome = env( "ANT_HOME" );
}

while ( strJavaHome.charAt(strJavaHome.length-1) == '\\' ) {
    strJavaHome = strJavaHome.substring(0, strJavaHome.length-1 );
}

while ( strAntHome.charAt(strAntHome.length-1) == '\\' ) {
    strAntHome = strAntHome.substring(0, strAntHome.length-1 );
}

// if java properties is not defined - ERROR!!!

if ( strJavaHome == "" ) {
    buildErr += getMessage("JAVA_BUILD_JDK_PATH_IS_NOT_SPECIFIED")+"\n";
}
if ( strAntHome == "" ) {
    buildErr += getMessage("JAVA_BUILD_ANT_PATH_IS_NOT_SPECIFIED")+"\n";
}

if ( buildErr == "" ) {
    if ( ! ccsFileSystem.Exists( strJavaHome + "\\bin\\java.exe" ) ) {
        buildErr += getMessage("JAVA_BUILD_FILE_NOT_FOUND_IN_FOLDER").replace(/{filename}/i, "java.exe").replace(/{foldername}/i, strJavaHome + "\\bin")+"\n";
    }
    if ( ! ccsFileSystem.Exists( strAntHome + "\\bin\\ant.bat" ) ) {
        buildErr += getMessage("JAVA_BUILD_FILE_NOT_FOUND_IN_FOLDER").replace(/{filename}/i, "ant.bat").replace(/{foldername}/i, strAntHome + "\\bin")+"\n";
    }
}

// path to temporary directory for build LiveData application
var path = project.publishPath(false)+"\\CCSBuild\\";
var logFile = path+"build.log";

//Check connections attributes
var useDs = project.getProperty( "ds" );
if ( useDs != "True" ) {
    var conns = project.Collection( "Connections" );
    for ( var i = 1; i<=conns.count; i++ ) {
        var conn = conns.Item( i );
        var dbDriver = conn.getProperty( "dbDriver" );
        var dbUrl = conn.getProperty( "dbURL" );
        if ( dbDriver == null || dbDriver == "" ) {
            buildErr += getMessage("JAVA_BUILD_JDBC_DRIVER_IS_REQUIRED").replace(/{connectionName}/i, conn.getProperty( "name" )) + "\n";
        }
        if ( dbUrl == null || dbUrl == "" ) {
            buildErr += getMessage("JAVA_BUILD_DB_URL_IS_REQUIRED").replace(/{connectionName}/i, conn.getProperty( "name" )) + "\n";
        }
    }
}

if ( buildErr != "" ) {
    mesWindow.AddLogEntry( 3, "\n"+getMessage("JAVA_BUILD_FAILED")+"\n" + buildErr );
} else {

    if ( ccsFileSystem.Exists ( logFile ) ) {
        var result = 1;
        result = ccsFileSystem.FileDelete( logFile, true );
    }

    var OS = env ( "OS" );
    var cmdOs = "command.com";
    if ( OS == "Windows_NT" ) {
        cmdOs = "cmd";
    }

    // build command and parameters for building application
    var antCmd = "call \"" + strAntHome + "\\bin\\ant.bat\"";
    var antExists = true;
    var buildResult = false;
    if ( antCmd != "" ) {

        var params = " -buildfile \"" + path + "build.xml\"";// + " -logfile \"" + logFile + "\"";
        var cmd = antCmd;

        mesWindow.AddLogEntry( 1, cmd + " " + params + " -logfile \"" + logFile + "\"" );
        mesWindow.AddLogEntry( 1, getMessage("JAVA_BUILD_DELIMETER"));

        antCmd = "@Echo Off\r\n" +
                "SET JAVA_HOME="+strJavaHome+"\r\n" +
                "SET ANT_HOME="+strAntHome+"\r\n" +
                antCmd + " -version\r\n" +
                antCmd
                ;
        ccsFileSystem.SaveFileContent( path + "build.bat", antCmd + params );
        
        sh.Sleep(3000); //workaround for XP
        
        sh.Run( cmdOs, " /E:8192 /c \"" + path + "build.bat\"", logFile, project.application  );

        // output ant-message file to message window
        var buildLog = "";
        var antErrs = "";
        if ( ccsFileSystem.Exists ( logFile ) ) {
            buildLog = ccsFileSystem.ReadFileContent( logFile );
        }

        var pos = buildLog.indexOf ( getMessage("JAVA_BUILD_ANT_BUILD_SUCCESSFUL_MESSAGE") );
        if ( pos > -1 ) {
            buildResult = true;
        } else {
            pos = buildLog.indexOf ("BUILD SUCCESSFUL");
        }    
        if ( pos > -1 ) {
            buildResult = true;
        } else {
            pos = buildLog.indexOf( getMessage("JAVA_BUILD_ANT_BUILD_FAILED_MESSAGE") );
            if (pos == -1) {
                pos = buildLog.indexOf("BUILD FAILED");
            }
            var pos1 = buildLog.indexOf( "Total time:" );
            if ( pos > -1 && pos1 > -1 ) {
                buildErr = buildLog.substring( pos + 12, pos1).replace(/\r\n\r\n/g, "\r\n");
                pos = buildErr.indexOf( "build.xml:" );
                if ( pos > -1 ) {
                    pos = buildErr.indexOf( ":", pos+1 );
                    pos = buildErr.indexOf( ":", pos+1 );
                    if ( pos > -1 ) {
                        buildErr = buildErr.substr( pos+2 );
                    }
                }
            }
        }
    }

    if ( ! ccsFileSystem.Exists ( logFile ) ) {
        buildResult = false;
        antErrs += getMessage("JAVA_BUILD_ANT_LOG_FILE_IS_ABSENT");
    }


    mesWindow.AddLogEntry( 1, getMessage("JAVA_BUILD_DELIMETER"));
    if ( buildResult ) {
        var projectName = project.getProperty( "name" );

        var appAsWar = project.getProperty( "appAsWar" );
        var contextPath = project.getProperty( "contextPath" );
        var tomcatServerPath = project.getProperty( "tomcatServerPath" ).replace(/\\/g, "\\\\");
        var urlToManager = project.getProperty( "urlToManager" );
        var serverUrl = project.getProperty( "localServerURL" );
        var loginToManager = project.getProperty( "loginToManager" );
        var passwordToManager = project.getProperty( "passwordToManager" );
        var targetServer = project.getProperty( "targetServer" );
        var dScripts = application.TypeLibList("JavaServersDeploymentScripts");

        var serverPath = project.getProperty( "localServerPath" );
        if ( targetServer.indexOf("omcat") > -1 && tomcatServerPath != "") {
            serverPath = tomcatServerPath;
        }
        serverPath = serverPath.replace(/\\/g, "/");
        if ( serverPath.charAt(0) != "/" ) serverPath = "/" + serverPath;

        var count = dScripts.Count;
        var script = "";
        for ( var i = 1; i <= count; i++ ) {
            var s = dScripts.Item(i);
            if ( s.Name == targetServer ) {
                script = strCCSHome+"\\Components\\"+s.Value;
            }
        }
        if ( script != "" ) {
            var pos = serverUrl.indexOf("//");
            var webApp = "";
            if ( pos > -1 ) {
                pos = serverUrl.indexOf("/",pos+2);
                if ( pos > -1 ) {
                    webApp = serverUrl.substring(pos);
                }
            }
            if ( contextPath != "" ) {
                webApp = contextPath;
            }
            if ( webApp != "" ) {
                var dScript = "";
                if ( ccsFileSystem.Exists ( script ) ) {
                    dScript = ccsFileSystem.ReadFileContent(script);
                    if ( dScript != "" ) {
                        if ( pageName == "" ) {
                            dScript = replace("{pageName}", "/Nothing"+pageExt, dScript);
                        } else {
                            dScript = replace("{pageName}", pageName, dScript);
                        }
                        if ( appAsWar == "False" ) {
                            if ( contextPath == "" ) {
                                dScript = replace("{projectName}", projectName, dScript);
                            } else {
                                dScript = replace("{projectName}", contextPath.substr(1), dScript);
                            }
                        } else {
                            dScript = replace("{projectName}", projectName, dScript);
                        }
                        dScript = replace("{serverPath}", serverPath, dScript);
                        dScript = replace("{serverUrl}", serverUrl, dScript);
                        dScript = replace("{appPath}", webApp, dScript);
                        dScript = replace("{urlToManager}", urlToManager, dScript);
                        dScript = replace("{login}", loginToManager, dScript);
                        dScript = replace("{password}", passwordToManager, dScript);
                        if ( appAsWar == "False" ) {
                            dScript = replace("{appAsWar}", "false", dScript);
                        } else {
                            dScript = replace("{appAsWar}", "true", dScript);
                        }
                        ccsFileSystem.SaveFileContent( path + "deployApp.js", dScript );
                    }
                }

            }
        }

        if ( appAsWar == "False" ) {
            ccPage.namedValue("deploymentFile") = "";
            ccPage.namedValue("deploymentDir") = path + "app";
            ccPage.namedValue("result") = "true";
        } else {
            ccPage.namedValue("deploymentFile") = "";
            ccPage.namedValue("deploymentDir") = path + "appWar";
            ccPage.namedValue("result") = "true";
        }
        mesWindow.AddLogEntry( 1, getMessage("JAVA_BUILD_FINISHED") );
    } else {
        ccPage.namedValue("deploymentFile") = "";
        ccPage.namedValue("deploymentDir") = "";
        ccPage.namedValue("result") = "false";

        var errString = buildErr + antErrs;
        mesWindow.AddLogEntry( 3, "\n"+getMessage("JAVA_BUILD_FAILED")+"\n" + (errString=="" ? getMessage("JAVA_BUILD_ADDINFO") :errString) );
    }

}

function replace( template, body, str ) {
    if ( template == null || body == null || str == null ) return str;
    var pos = str.lastIndexOf( template );
    while ( pos > -1 ) {
        str = str.substring( 0, pos ) + body +
                str.substring( pos + template.length, str.length )
        pos = str.lastIndexOf( template );
    }
    return str;
}

function firstReplace( template, body, str ) {
    if ( template == null || body == null || str == null ) return str;
    var pos = str.indexOf( template );
    if ( pos > -1 ) {
        str = str.substring( 0, pos ) + body +
                str.substring( pos + template.length, str.length )
    }
    return str;
}

function getMessage(key) {
    return application.translations.resourceString(key);
}
